#ifndef __KYSEC_API_H__
#define __KYSEC_API_H__

#include <dlfcn.h>
#include <syslog.h>
#include <locale.h>
#include <errno.h>
#include <stdio.h>

/*
 * 1 检测通过， 0 检测失败
 */
static int kysec_check_api(char *path)
{
    void *handle = NULL;
    int (*check)(char *);
    char *error;
    int retval = 0;

#ifdef HAVE_DLOPEN
    handle = dlopen("libkysec.so.0", RTLD_LAZY);
#else
    return 1;
#endif
    if (!handle) {
        syslog(LOG_INFO, "Failed to open libkysec - %s", dlerror());
        return 1;
    }

    dlerror();

    check = (int (*)(char *)) dlsym(handle, "kysec_check_exec");
    error = dlerror();
    if (error) {
        syslog(LOG_INFO, "Failed to obtain address of symbol - %s", error);
        dlclose(handle);
        return 1;
    }

    retval = (*check)(path);
    dlclose(handle);
    return retval;
}

static void print_kysec_err()
{
    setlocale(LC_ALL, "");
    errno = EACCES;
    perror("KYSEC");
}

#endif
